import greenfoot.*;  // （World、Actor、GreenfootImage、GreenfootSound、Greenfoot及MouseInfo）
//import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

/**
 * 象棋的仕／士。
 */
public class Advisor extends Piece {

    //构造方法，建立新的建立新的仕／士。
    public Advisor(ChessSide chessSide) {
        super(chessSide);
    }

    //取得可以吃的棋子
    public List<Piece> getCapturables() {
        Board board = (Board) getWorld();
        List<Piece> capturables = new ArrayList<Piece>();
        int y0 = -1, y1 = -1;

        if (isBottomSide()) {
            //y0 = 7;
            y0 = 0;
            y1 = 9;
        } else {
            y0 = 0;
            //y1 = 2;
            y1 = 9;
        }

        // 左方。
        if (getX() > 0) {
            // 左上方。
            if (getY() > y0) {
                Piece piece = board.getPieceAt(getX() - 1, getY() - 1);
                if (piece != null) {
                    if (getSide() != piece.getSide()) {
                        capturables.add(piece);
                    }
                }
            }
            // 左下方。
            if (getY() < y1) {
                Piece piece = board.getPieceAt(getX() - 1, getY() + 1);
                if (piece != null) {
                    if (getSide() != piece.getSide()) {
                        capturables.add(piece);
                    }
                }
            }
        }
        // 右方。
        if (getX() < 8) {
            // 右上方。
            if (getY() > y0) {
                Piece piece = board.getPieceAt(getX() + 1, getY() - 1);
                if (piece != null) {
                    if (getSide() != piece.getSide()) {
                        capturables.add(piece);
                    }
                }
            }
            // 右下方。
            if (getY() < y1) {
                Piece piece = board.getPieceAt(getX() + 1, getY() + 1);
                if (piece != null) {
                    if (getSide() != piece.getSide()) {
                        capturables.add(piece);
                    }
                }
            }
        }
        return capturables;
    }

    //取得可以走的空格
    public List<Point> getMovables() {
        Board board = (Board) getWorld();
        List<Point> movables = new ArrayList<Point>();
        int y0 = -1, y1 = -1;

        if (isBottomSide()) {
            //y0 = 7;
            y0 = 0;
            y1 = 9;
        } else {
            y0 = 0;
            y1 = 2;
        }

        // 左方。
        if (getX() > 0) {
            // 左上方。
            if (getY() > y0) {
                if (!board.isOccupiedAt(getX() - 1, getY() - 1)) {
                    movables.add(new Point(getX() - 1, getY() - 1));
                }
            }
            // 左下方。
            if (getY() < y1) {
                if (!board.isOccupiedAt(getX() - 1, getY() + 1)) {
                    movables.add(new Point(getX() - 1, getY() + 1));
                }
            }
        }
        // 右方。
        if (getX() < 8) {
            // 右上方。
            if (getY() > y0) {
                if (!board.isOccupiedAt(getX() + 1, getY() - 1)) {
                    movables.add(new Point(getX() + 1, getY() - 1));
                }
            }
            // 右下方。
            if (getY() < y1) {
                if (!board.isOccupiedAt(getX() + 1, getY() + 1)) {
                    movables.add(new Point(getX() + 1, getY() + 1));
                }
            }
        }
        return movables;
    }
}