import greenfoot.*;  // （World、Actor、GreenfootImage、GreenfootSound、Greenfoot及MouseInfo）
//import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

/**
 * 象棋的俥/車。
 */
public class Chariot extends Piece {

    //构造方法，建立新的俥/車
    public Chariot(ChessSide chessSide) {
        super(chessSide);
    }

    //取得可以吃的棋子
    public List<Piece> getCapturables() {
        Board board = (Board) getWorld();
        List<Piece> capturables = new ArrayList<Piece>();

        for (int x = getX() - 1; x >= 0; x--) {
            Piece piece = board.getPieceAt(x, getY());
            if (piece != null) {
                if (getSide() != piece.getSide()) {
                    capturables.add(piece);
                }
                break;
            }
        }
        for (int x = getX() + 1; x < 9; x++) {
            Piece piece = board.getPieceAt(x, getY());
            if (piece != null) {
                if (getSide() != piece.getSide()) {
                    capturables.add(piece);
                }
                break;
            }
        }
        for (int y = getY() - 1; y >= 0; y--) {
            Piece piece = board.getPieceAt(getX(), y);
            if (piece != null) {
                if (getSide() != piece.getSide()) {
                    capturables.add(piece);
                }
                break;
            }
        }
        for (int y = getY() + 1; y < 10; y++) {
            Piece piece = board.getPieceAt(getX(), y);
            if (piece != null) {
                if (getSide() != piece.getSide()) {
                    capturables.add(piece);
                }
                break;
            }
        }
        return capturables;
    }

    //取得可以走的空格
    public List<Point> getMovables() {
        Board board = (Board) getWorld();
        List<Point> movables = new ArrayList<Point>();

        for (int x = getX() - 1; x >= 0; x--) {
            if (board.isOccupiedAt(x, getY())) {
                break;
            }
            movables.add(new Point(x, getY()));
        }
        for (int x = getX() + 1; x < 9; x++) {
            if (board.isOccupiedAt(x, getY())) {
                break;
            }
            movables.add(new Point(x, getY()));
        }
        for (int y = getY() - 1; y >= 0; y--) {
            if (board.isOccupiedAt(getX(), y)) {
                break;
            }
            movables.add(new Point(getX(), y));
        }
        for (int y = getY() + 1; y < 10; y++) {
            if (board.isOccupiedAt(getX(), y)) {
                break;
            }
            movables.add(new Point(getX(), y));
        }
        return movables;
    }
}