import greenfoot.*;  // （World、Actor、GreenfootImage、GreenfootSound、Greenfoot及MouseInfo）

import java.util.List;
import java.io.File;
import javax.imageio.ImageIO;

/**
 * 当前走棋方类，显示当前轮到哪一方走棋
 */
public class CurrentSide extends Actor {
    
    private GreenfootImage sideRed = new GreenfootImage("side-red.png"); //显示红方走棋  
    private GreenfootImage sideBlack = new GreenfootImage("side-black.png");  //显示黑方走棋
    
    //构造方法，初始化走棋方图像
    public CurrentSide(ChessSide side) {
        switch (side) {
        case RED:
            setImage(sideRed);
            break;
        case BLACK:
            setImage(sideBlack);
            break;
        }
    }
    
    //切换走棋方
    public void switchSide() {
        if (getImage() == sideRed) {
            setImage(sideBlack);
        } else {
            setImage(sideRed);
        }
    }
}