import greenfoot.*;  // （World、Actor、GreenfootImage、GreenfootSound、Greenfoot及MouseInfo）
//import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

/**
 * 象棋的兵／卒。
 */
public class Soldier extends Piece {

    //构造方法，建立新的兵/卒
    public Soldier(ChessSide chessSide) {
        super(chessSide);
    }

    //取得可以吃的棋子
    public List<Piece> getCapturables() {
        Board board = (Board) getWorld();
        List<Piece> capturables = new ArrayList<Piece>();        

        if (isBottomSide()) {
            /*
            // 未过河。
            if (getY() > 4) {
            Piece piece = board.getPieceAt(getX(), getY() - 1);
            if (piece != null) {
            if (getSide() != piece.getSide()) {
            capturables.add(piece);
            }
            }

            // 已过河。
            } else {*/
            Piece piece = null;
            piece = board.getPieceAt(getX(), getY() - 1);
            if (piece != null) {
                if (getSide() != piece.getSide()) {
                    capturables.add(piece);
                }
            }
            piece = board.getPieceAt(getX() - 1, getY());
            if (piece != null) {
                if (getSide() != piece.getSide()) {
                    capturables.add(piece);
                }
            }
            piece = board.getPieceAt(getX() + 1, getY());
            if (piece != null) {
                if (getSide() != piece.getSide()) {
                    capturables.add(piece);
                }
            }

        } else {
            /* 未过河。
            if (getY() < 5) {
            Piece piece = board.getPieceAt(getX(), getY() + 1);
            if (piece != null) {
            if (getSide() != piece.getSide()) {
            capturables.add(piece);
            }
            }

            // 已过河。
            } else { */
            Piece piece = null;
            piece = board.getPieceAt(getX(), getY() + 1);
            if (piece != null) {
                if (getSide() != piece.getSide()) {
                    capturables.add(piece);
                }
            }
            piece = board.getPieceAt(getX() - 1, getY());
            if (piece != null) {
                if (getSide() != piece.getSide()) {
                    capturables.add(piece);
                }
            }
            piece = board.getPieceAt(getX() + 1, getY());
            if (piece != null) {
                if (getSide() != piece.getSide()) {
                    capturables.add(piece);
                }
            }

        }
        return capturables;
    }

    //取得可以走的空格
    public List<Point> getMovables() {
        Board board = (Board) getWorld();
        List<Point> movables = new ArrayList<Point>();

        if (isBottomSide()) {
            /*
            // 未过河。
            if (getY() > 4) {
            if (!board.isOccupiedAt(getX(), getY() - 1)) {
            movables.add(new Point(getX(), getY() - 1));
            }

            // 已过河。
            } else {*/
            if (!board.isOccupiedAt(getX(), getY() - 1)) {
                movables.add(new Point(getX(), getY() - 1));
            }
            if (getX()>0 && !board.isOccupiedAt(getX() - 1, getY())) {
                movables.add(new Point(getX() - 1, getY()));
            }
            if (getX()<8 && !board.isOccupiedAt(getX() + 1, getY())) {
                movables.add(new Point(getX() + 1, getY()));
            }

        } else {
            // 未过河。
            if (getY() < 5) {
                if (!board.isOccupiedAt(getX(), getY() + 1)) {
                    movables.add(new Point(getX(), getY() + 1));
                }

                // 已过河。
            } else {
                if (!board.isOccupiedAt(getX(), getY() + 1)) {
                    movables.add(new Point(getX(), getY() + 1));
                }
                if (!board.isOccupiedAt(getX() - 1, getY())) {
                    movables.add(new Point(getX() - 1, getY()));
                }
                if (!board.isOccupiedAt(getX() + 1, getY())) {
                    movables.add(new Point(getX() + 1, getY()));
                }
            }
        }
        return movables;
    }
}